<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Block Nodes</TITLE>
<link href="suif1_19.html" rel=Next>
<link href="suif1_17.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_17.html">previous</A>, <A HREF="suif1_19.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC18" HREF="suif1_toc.html#TOC18">Block Nodes</A></H3>
<P>
<A NAME="IDX106"></A>
<A NAME="IDX107"></A>
<A NAME="IDX108"></A>

</P>
<P>
<A NAME="IDX109"></A>
A <CODE>tree_block</CODE> node introduces a new scope.  Nested scopes are
useful for retaining scope information from source programs and for
debugging purposes.  They are also very useful for implementing code
transformations.  For example, name conflicts are easily avoided by
introducing new scopes.

</P>
<P>
<A NAME="IDX110"></A>
<A NAME="IDX111"></A>
<A NAME="IDX112"></A>
<A NAME="IDX113"></A>
A <CODE>tree_block</CODE> node contains a <CODE>block_symtab</CODE> symbol table and
a tree node list for the body.  The symbol table is accessed with the
<CODE>symtab</CODE> and <CODE>set_symtab</CODE> methods.  The <CODE>body</CODE> and
<CODE>set_body</CODE> methods are used to get and set the list of tree nodes
inside the block.

</P>
<P>
There is a one-to-one correspondence between a <CODE>tree_block</CODE> and its
symbol table, and the hierarchy of symbol tables within a procedure must
parallel the hierarchy of <CODE>tree_block</CODE> nodes.  When inserting a
<CODE>tree_block</CODE> into an AST, the new block's symbol table must be
inserted in the appropriate place in the symbol table hierarchy.  When a
<CODE>tree_block</CODE> is destroyed, the associated symbol table is detached
from its parent table and destroyed.  However, the converse is not
true--when a <CODE>block_symtab</CODE> is deleted, the corresponding
<CODE>tree_block</CODE> node is not deleted.

</P>
<P>
The entries in a block's symbol table may not be referenced from outside
the block.  There are no other restrictions on <CODE>tree_block</CODE> nodes.
The bodies may be empty or contain any kinds of tree nodes.  Blocks are
usually entered from the beginning but that is not required; unlike
other AST nodes, branches into the middle of a block are allowed.

</P>
<P>
As an example, the following code creates a new <CODE>tree_block</CODE> and
its associated symbol table.  It then adds the new block to the
body of an existing block node:

</P>

<PRE>
block_symtab *new_symtab = new block_symtab("my_symtab");
cur_block-&#62;symtab()-&#62;add_child(new_symtab);
tree_node_list *tl = new tree_node_list;
tree_block *new_block = new tree_block(tl, new_symtab);
cur_block-&#62;body()-&#62;append(new_block);
</PRE>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_17.html">previous</A>, <A HREF="suif1_19.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
